<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/FEMB_DAQ/FEMB_Rx.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_a3585d810a6146e99cf3db60911d03bd.html">FEMB_DAQ</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">FEMB_Rx.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classWIB__Constants.html">WIB_Constants</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classFEMB__DAQ__IO.html">FEMB_DAQ_IO</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="code" href="classFEMB__Rx.html">   18</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classFEMB__Rx.html" title="The FEMB_RxTx modulue handles the transceiver streams and user logic interface.">FEMB_Rx</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  <span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="code" href="classFEMB__Rx.html#a6e02a9aa1a47b461fd9227c7b9a55ae3">   21</a></span>&#160;    <span class="vhdlchar"><a class="code" href="classFEMB__Rx.html#a6e02a9aa1a47b461fd9227c7b9a55ae3" title="user logic clock">clk_in</a></span>             <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="code" href="classFEMB__Rx.html#a0418e1bc437edc44e466437075624953">   22</a></span>&#160;    <span class="vhdlchar"><a class="code" href="classFEMB__Rx.html#a0418e1bc437edc44e466437075624953" title="Rx input.">Rx</a></span>                 <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="code" href="classFEMB__Rx.html#aecaeeeff0d0a6ba319430622670dff83">   23</a></span>&#160;    <span class="vhdlchar"><a class="code" href="classFEMB__Rx.html#aecaeeeff0d0a6ba319430622670dff83" title="reference clock for the Rx">Rx_refclk</a></span>          <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_GROUPS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="vhdlchar">rx_data</span>            <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">data_8b10b_t</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="vhdlchar">monitor</span>            <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">FEMB_COLDATA_Rx_Monitor_array_t</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="vhdlchar">control</span>            <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="vhdlchar">FEMB_COLDATA_Rx_Control_array_t</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">entity</span> <span class="vhdlchar">FEMB_Rx</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="code" href="classFEMB__Rx_1_1behavioral.html">   31</a></span>&#160;<span class="vhdlkeyword">architecture</span> behavioral <span class="vhdlkeyword">of</span> <a class="code" href="classFEMB__Rx.html" title="The FEMB_RxTx modulue handles the transceiver streams and user logic interface.">FEMB_Rx</a> is</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">  ---------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">  -- COLD Data transceiver interface components</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  <span class="vhdlkeyword">component</span> COLDATA_Rx <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;      rx_analogreset          : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;      rx_digitalreset         : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;      rx_cdr_refclk           : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;      rx_serial_data          : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;      rx_is_lockedtoref       : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;      rx_is_lockedtodata      : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;      rx_std_coreclkin        : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;      rx_std_clkout           : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;      rx_cal_busy             : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;      reconfig_to_xcvr        : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">279</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>) := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;      reconfig_from_xcvr      : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">183</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;      rx_parallel_data        : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      rx_datak                : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;      rx_errdetect            : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      rx_disperr              : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;      rx_runningdisp          : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;      rx_patterndetect        : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;      rx_syncstatus           : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      unused_rx_parallel_data : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">199</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>));</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">COLDATA_Rx</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  <span class="vhdlkeyword">constant</span> <span class="vhdlchar">GROUP_SIZE</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">/</span><span class="vhdlchar">LINK_GROUPS</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">  ---------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">  -- COLD Data transceiver interface components</span><span class="keyword"></span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">  ---------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">fboutclk</span> <span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">reconfig_to_RxTx_xcvr</span>   <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">70</span><span class="vhdlchar">)</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">reconfig_from_RxTx_xcvr</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">46</span><span class="vhdlchar">)</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rx_data_reordered</span>   <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rx_data_k_reordered</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>     <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">core_clk</span>            <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">LINK_COUNT</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>     <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">--  <span class="vhdlkeyword">signal</span> rx_data_buffer      : data_8b10b_t(LINK_COUNT <span class="vhdlkeyword">downto</span> </span><span class="vhdllogic">1</span>);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="vhdlkeyword">begin </span><span class="keyword"> -- <span class="vhdlkeyword">architecture</span> behavioral</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">  --Transceiver IP CORE (look over right <span class="vhdlkeyword">and</span> left clocked IOs)</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  <span class="vhdlchar">refclk_group</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">for</span> <span class="vhdlchar">iRefClk</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">LINK_GROUPS</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="vhdlchar">monitor</span><span class="vhdlchar">(</span><span class="vhdlchar">iRefClk</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">rx_analogreset</span>  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">(</span><span class="vhdlchar">iRefClk</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">rx_analogreset</span>;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="vhdlchar">monitor</span><span class="vhdlchar">(</span><span class="vhdlchar">iRefClk</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">rx_digitalreset</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">(</span><span class="vhdlchar">iRefClk</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">rx_digitalreset</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    COLDATA_Rx_1 : COLDATA_Rx</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;      <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        rx_analogreset           =&gt; control<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_analogreset,</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        rx_digitalreset          =&gt; control<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_digitalreset,</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        rx_cdr_refclk            =&gt; <a class="code" href="classFEMB__Rx.html#aecaeeeff0d0a6ba319430622670dff83" title="reference clock for the Rx">Rx_refclk</a><span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        rx_serial_data           =&gt; <a class="code" href="classFEMB__Rx.html#a0418e1bc437edc44e466437075624953" title="Rx input.">Rx</a>      <span class="vhdlchar">(</span><span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span> - <span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        rx_is_lockedtoref        =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_is_lockedtoref,</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        rx_is_lockedtodata       =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_is_lockedtodata,</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        rx_std_coreclkin         =&gt; core_clk<span class="vhdlchar">(</span><span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span> - <span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        rx_std_clkout            =&gt; <span class="vhdlkeyword">open</span>,</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        rx_cal_busy              =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_cal_busy,</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        reconfig_to_xcvr         =&gt; reconfig_to_RxTx_xcvr    <span class="vhdlchar">(</span><span class="vhdlchar">(</span>70*GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span> -<span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">(</span>70*GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        reconfig_from_xcvr       =&gt; reconfig_from_RxTx_xcvr  <span class="vhdlchar">(</span><span class="vhdlchar">(</span>46*GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span> -<span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">(</span>46*GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        rx_parallel_data         =&gt; rx_data_reordered <span class="vhdlchar">(</span>  <span class="vhdllogic">8*</span><span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span> - <span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic">8*</span><span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        rx_datak                 =&gt; rx_data_k_reordered<span class="vhdlchar">(</span>  <span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span> - <span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span>   <span class="vhdlchar">(</span>GROUP_SIZE<span class="vhdlchar">)</span>*<span class="vhdlchar">(</span>iRefClk-<span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        rx_errdetect             =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_errdetect,</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        rx_disperr               =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_disperr,</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        rx_runningdisp           =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_runningdisp,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        rx_patterndetect         =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_patterndetect,</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        rx_syncstatus            =&gt; monitor<span class="vhdlchar">(</span>iRefClk<span class="vhdlchar">)</span>.rx_syncstatus,</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        unused_rx_parallel_data  =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span> <span class="vhdlchar">refclk_group</span>;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">  -- clock <span class="vhdlkeyword">for</span> the user logic side <span class="vhdlkeyword">of</span> the FIFOs</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  <span class="vhdlchar">core_clk</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar"><a class="code" href="classFEMB__Rx.html#a6e02a9aa1a47b461fd9227c7b9a55ae3" title="user logic clock">clk_in</a></span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">--  links : <span class="vhdlkeyword">for</span> iLink <span class="vhdlkeyword">in</span> LINK_COUNT <span class="vhdlkeyword">downto</span> </span><span class="vhdllogic">1</span> <span class="vhdlkeyword">generate</span><span class="keyword"></span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">--    --Reorder separated 8b+k characters <span class="vhdlkeyword">to</span> one <span class="vhdlkeyword">block</span> <span class="vhdlkeyword">for</span> IP</span><span class="keyword"></span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">--    -- rx</span><span class="keyword"></span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">--    rx_data(iLink)(</span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic">0</span>) &lt;= rx_data_reordered((iLink*8) -1 <span class="vhdlkeyword">downto</span> (iLink-1)*8);<span class="keyword"></span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">--    rx_data(iLink)(</span><span class="vhdllogic">8</span>)          &lt;= rx_data_k_reordered(iLink-1);<span class="keyword"></span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">--  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span> links;</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">  --Reorder the bits <span class="vhdlkeyword">for</span> logic outside</span><span class="keyword"></span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keyword">  -- Lessen the burden <span class="vhdlkeyword">on</span> the timing <span class="vhdlkeyword">of</span> these signals <span class="vhdlkeyword">with</span> a pipeline delay</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;  link_reorder_and_pipeline_delay: <span class="vhdlkeyword">process</span> (<a class="code" href="classFEMB__Rx.html#a6e02a9aa1a47b461fd9227c7b9a55ae3" title="user logic clock">clk_in</a>) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> link_reorder_and_pipeline_delay</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar"><a class="code" href="classFEMB__Rx.html#a6e02a9aa1a47b461fd9227c7b9a55ae3" title="user logic clock">clk_in</a></span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar"><a class="code" href="classFEMB__Rx.html#a6e02a9aa1a47b461fd9227c7b9a55ae3" title="user logic clock">clk_in</a></span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;      <span class="vhdlkeyword">for</span> <span class="vhdlchar">iLink</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">LINK_COUNT</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">loop</span><span class="keyword"></span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword">        --Reorder separated 8b+k characters <span class="vhdlkeyword">to</span> one <span class="vhdlkeyword">block</span> <span class="vhdlkeyword">for</span> IP</span><span class="keyword"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">        -- rx</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="vhdlchar">rx_data</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">rx_data_reordered</span><span class="vhdlchar">(</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="vhdlchar">rx_data</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span>          <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">rx_data_k_reordered</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">loop</span>;<span class="keyword">  -- iLink</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">link_reorder_and_pipeline_delay</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;  </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">behavioral</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:31 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
